// All Rights Reserved, Copyright (c) FUJITSU LIMITED 2002
#include    <stdlib.h>
#include    <string.h>
#include    "orb_cplus.h"
#include    "CosNaming_cplus.h"
#include    "EventService_cplus.h"

// ----------------------------------------------------------------
CORBA::Any *
CosEventComm_PullSupplier_impl::pull(
    CORBA::Environment  & )
    throw( CORBA::Exception )
{
    CORBA::Any          *reply = new CORBA::Any();
    CORBA::Char         *message;

    message = CORBA::string_alloc( strlen("Pull-C++") );
#if defined(_MSC_VER) && (_MSC_VER >= 1400)
    strcpy_s( message, strlen("Pull-C++")+1, "Pull-C++" );
#else
    strcpy( message, "Pull-C++" );
#endif
    reply->replace( _tc_string, message, CORBA_TRUE );

    return( reply );
}

// --------------------------------------------------------------------
CORBA::Any *
CosEventComm_PullSupplier_impl::try_pull(
    CORBA::Boolean      &has_event,
    CORBA::Environment  &env )
    throw( CORBA::Exception )
{
    CORBA::Any          *reply = NULL;

    try {
        reply = CosEventComm_PullSupplier_impl::pull( env );
    } catch( CORBA::Exception &e ) {
        has_event = CORBA_FALSE;
        return( reply );
    }
    has_event = CORBA_TRUE;

    return( reply );
}

// --------------------------------------------------------------------
void
CosEventComm_PullSupplier_impl::disconnect_pull_supplier(
    CORBA::Environment    & )
    throw( CORBA::Exception )
{
    printf( "disconnect\n" );

    return;
}

